package src;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;

// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
import java.util.Random;
// </editor-fold> 

public class Partida {

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.AAD7E6C1-1036-7F57-308D-474E893A6D91]
    // </editor-fold> 
    private Tablero tablero;//tablero de la partida

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.AB81F2E2-1DDE-961D-29E9-10BE7ACDDD6B]
    // </editor-fold> 
    private ArrayList<Jugador> jugadores;//array que contiene los jugadores de la partida
    private int turno = 0;//variable para saber que jugador tiene el turno

    public Partida(Tablero tableroParti) throws java.io.IOException {
        BufferedReader teclado = new BufferedReader(new InputStreamReader(System.in));
        String linea = null;




        System.out.println("Cuantos jugadores jugaran hoy? (2-6)");

        linea = teclado.readLine();
        int numJugadores = Integer.parseInt(linea);//pasamos a int el dato introducido por teclado que nos llega como String

        //bucle en el que comprobamos que el numero introducido es el correcto
        while ((numJugadores < 2) || (numJugadores > 6)) {
            System.out.println("Numero de jugadores incorrecto. Pruebe de nuevo.");
            System.out.println("Cuantos jugadores jugaran hoy? (2-6)");

            linea = teclado.readLine();
            numJugadores = Integer.parseInt(linea);
        }

        jugadores = new ArrayList<Jugador>(numJugadores);//creamos el array de jugadores

        for (int i = 0; i < numJugadores; i++) {
            System.out.println("Introduzca el nombre del jugador " + (i + 1) + ":");
            //Aqui implementar confirmacion de nombre, por si se equivoca al introducirlo.
            linea = teclado.readLine();
            jugadores.add(new Jugador(linea, i));
        }
        setJugador(jugadores);
        setTablero(tableroParti);
    }

    private void aleatorioJugador() {
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.4F6F0C3E-AB37-B9A9-E685-CABB2D1F3D76]
    // </editor-fold> 
    public ArrayList<Jugador> getJugador() {
        return jugadores;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.F568669E-193B-52C1-E637-0CD07A354CC6]
    // </editor-fold> 
    public void setJugador(ArrayList<Jugador> val) {
        jugadores = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.E36CBC13-E609-242B-94E7-4E12D110E79B]
    // </editor-fold> 
    public Tablero getTablero() {
        return tablero;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.0D1D7706-642D-57EF-2648-DF15DC30B9CC]
    // </editor-fold> 
    public void setTablero(Tablero val) {
        tablero = val;
    }

    public void jugar() throws IOException {
        char accion = 'a';//variable que contiene la accion del menu escogida por el jugador

        int i = 0;
        //comprobar q sean creado todos los paises y sus adyacentes
//        ArrayList<Territorio> ter = tablero.getTerritorio();
//        ArrayList<Territorio> ady;
//        Iterator it = ter.iterator();
//        Iterator it2;
//        System.out.println("territorios:");
//        while(it.hasNext()){
//            Territorio t = (Territorio) it.next();
//            System.out.println(t.getNombreTerritorio());
//            ady = t.getTerritoriosAdy();
//            if (ady != null){
//                it2 = ady.iterator();
//                while(it2.hasNext()){
//                    Territorio terr = (Territorio) it2.next();
//                    System.out.println("\t"+terr.getNombreTerritorio());
//                }
//            }
//        }
//        //comprobar que se han creado los continente y que estos contienen sus territorios
//        ArrayList<Continente> ter = tablero.getContinente();
//        ArrayList<Territorio> ady;
//        Iterator it = ter.iterator();
//        Iterator it2;
//        System.out.println("continentes:");
//        while(it.hasNext()){
//            Continente t = (Continente) it.next();
//            System.out.println(t.getNombreContinente());
//            ady = t.getTerritorio();
//            if (ady != null){
//                it2 = ady.iterator();
//                while(it2.hasNext()){
//                    Territorio terr = (Territorio) it2.next();
//                    System.out.println("\t"+terr.getNombreTerritorio());
//                }
//            }
//        }

        System.out.println();
        System.out.println("*****************");
        System.out.println("COMIENZA EL JUEGO");
        System.out.println("*****************");
        System.out.println();

        //Inicializamos el juego para que los jugadores ubiquen sus tropas iniciales
        //y escojan los territorios con los que empezaran
        inicializarTropas();

        int trno = 1;//variable que contara las ronda de la partida

        while (accion != 'q') {

            System.out.println();
            System.out.println("--------");
            System.out.println("TURNO " + trno + ":");
            System.out.println("--------");
            System.out.println();

            turno = 0;

            // Ahora comprobamos los territorios y repartimos tropas
            // En el primer turno no se reparten tropas.
            if (trno != 1) rearmamiento();
            
            while (turno < jugadores.size() && accion != 'q') {
                System.out.println(jugadores.get(turno).getNombreJugador() + ", ES TU TURNO");
                accion = 'a';//inicializamos la variable para que pueda entrar en el bucle
                //bucle del cual se sale si pulsamos la opcion 'f' o la opcion 'q'
                //si pulsamos 'a' podremos seguir atacando


                //Comprobamos si tiene tropas en reserva y le obligamos a ubicarlas
                //mientras tenga tropas en reserva las tiene que colocar en los paises
                while (jugadores.get(turno).getTropasReserva() > 0) {
                    jugadores.get(turno).ubicarTropas();
                }

                //Comenzamos la fase de ataque
                //aqui deberiamos poner un case, mejor que varios else if.  Fran
                while ((accion == 'a' || accion == 'v') && (accion != 'm' || accion != 'f' || accion != 'q')) {
                    accion = jugadores.get(turno).jugarTurno();
                    if (accion == 'a') {
                        jugadores.get(turno).atacar();
                    } else if (accion == 'v') {
                        jugadores.get(turno).verCartas();
                    } else if (accion == 'f') {
                        System.out.println(jugadores.get(turno).getNombreJugador() + " termina su turno.");
                    } else if (accion == 'm') {
                        System.out.println(jugadores.get(turno).getNombreJugador() + " termina su fase de ataque.");
                        jugadores.get(turno).moverTropas();
                        System.out.println(jugadores.get(turno).getNombreJugador() + " termina su turno.");
                    }
                }
                turno++;
                System.out.println();
                System.out.println("/////////////////////////////////");
                System.out.println();
                System.out.println();
            }
            trno++;
        }
        System.out.println("Fin de partida");
    }

    public void rearmamiento() {
        //Este metodo comprobará los territorios que posee cada jugador y añadira
        //el numero de tropas de reserva que le correspondan.
        System.out.println("Comprobando Territorios y repartiendo tropas...");

        //Variable auxiliar para almacenar las tropas

        //Comprobamos todos los jugadores
        for (int i = 0; i < jugadores.size(); i++) {
            int tropasNuevas = 0;
            //Cogemos el numero de territorios que tiene y calculamos las tropas que
            //le corresponden, ignorando el resto de la division por 3
            tropasNuevas += (jugadores.get(i).getTerritorio().size()) / 3;

            //Ahora comprobamos los continentes que posee y le añadimos
            //las tropas segun le correspondan.
            if (jugadores.get(i).getContinente() != null) {
                for (int j = 0; j < jugadores.get(i).getContinente().size(); j++) {
                    tropasNuevas += jugadores.get(i).getContinente().get(j).getTropasPremio();
                }
            }

            // Cada jugador recibe al minimo 3 tropas por turno, aunque no tenga
            // territorios suficientes.
            if (tropasNuevas < 3) {
                tropasNuevas = 3;
            //Añadimos las tropas a la reserva del jugador
            }
            jugadores.get(i).setTropasReserva(tropasNuevas);
        }

    }

    public void inicializarTropas() throws IOException {
        //Este metodo ubicara el número de tropas iniciales en el primer turno
        //de juego.
        //ahora mismo este metodo realiza la asiganacion de los territorios automaticamente
        //es una de la posibilidades que le daremos al jugador


        int numJugadores = jugadores.size();
        //calculo de cuantos ejercitos se le debe asignar a cada jugador al comienzo del juego.
        int numeroEjercitos = 50 - (numJugadores * 5);
        //asignamos a cada jugador el numero de ejercitos correspondientes.
        for (int i = 0; i < numJugadores; i++) {
            jugadores.get(i).setTropasReserva(numeroEjercitos);
        }


        //empezamos a repartir los territorios de forma aleatoria entre los jugadores.
        int n = 42;  //numeros aleatorios

        int k = n;  //auxiliar;

        int[] numeros = new int[n];
        int[] resultado = new int[n];
        Random rnd = new Random();
        int res;


        //se rellena una matriz ordenada del 1 al 42(1..n)
        for (int i = 0; i < n; i++) {
            numeros[i] = i;
        }
        int j = 0;
        ArrayList<Territorio> repTerritorio = tablero.getTerritorio();
        int h;
        for (int i = 0; i < n; i++) {
            res = rnd.nextInt(k);
            resultado[i] = numeros[res];
            h = numeros[res];
            numeros[res] = numeros[k - 1];
            k--;
            jugadores.get(j).setTerritorio(repTerritorio.get(h));//asignamos el territorio al jugador

            repTerritorio.get(h).setPropietarioTer(jugadores.get(j));//asignamos el propietario al territorio

            jugadores.get(j).setTropasReserva((jugadores.get(j).getTropasReserva()) - 1); //Le quitamos la tropa para asignarla

            repTerritorio.get(h).setNumEjercito(1);//asignamos un ejercito al territorio

            j++;
            if (j >= numJugadores) {
                j = 0;
            }
        }
        
        //Obligamos a ubicar el resto de tropas restantes.
        for (int i = 0; i < jugadores.size(); i++) {
            while (jugadores.get(i).getTropasReserva() > 0) {
                jugadores.get(i).ubicarTropas();
            }
        }
    }
    /*private void rearmamiento(){
    for(int i=0;i < jugadores.size();i++){
    int numTerritorios = jugadores.get(i).getTerritorio().size();
    int numTropas = jugadores.get(i).getTropasReserva();
    if (numTerritorios < 12)
    jugadores.get(i).setTropasReserva((numTropas+3));
    else if(numTerritorios >=12 && numTerritorios <=14)
    jugadores.get(i).setTropasReserva((numTropas+4));
    else if(numTerritorios >=15 && numTerritorios <=17)
    jugadores.get(i).setTropasReserva((numTropas+5));
    else if(numTerritorios >=18 && numTerritorios <=20)
    jugadores.get(i).setTropasReserva((numTropas+6));
    else if(numTerritorios >=21 && numTerritorios <=23)
    jugadores.get(i).setTropasReserva((numTropas+7));
    else if(numTerritorios >=24 && numTerritorios <=26)
    jugadores.get(i).setTropasReserva((numTropas+8));
    else if(numTerritorios >=27 && numTerritorios <=29)
    jugadores.get(i).setTropasReserva((numTropas+9));
    else if(numTerritorios >=30 && numTerritorios <=32)
    jugadores.get(i).setTropasReserva((numTropas+10));
    else if(numTerritorios >=33 && numTerritorios <=35)
    jugadores.get(i).setTropasReserva((numTropas+11));
    else if(numTerritorios >=36 && numTerritorios <=38)
    jugadores.get(i).setTropasReserva((numTropas+12));
    else if(numTerritorios >=39 && numTerritorios <=41)
    jugadores.get(i).setTropasReserva((numTropas+13));
    
    ArrayList<Continente> conti = jugadores.get(i).getContinente();
    if(conti != null){
    for(int j=0;j<conti.size();j++){
    numTropas = jugadores.get(i).getTropasReserva();
    jugadores.get(i).setTropasReserva(numTropas+conti.get(i).getTropasPremio());
    }
    }
    }
    }*/
}

